package scripts;

import jinro.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.dnd.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

class IRCConnectDialog {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("IRCConnectDialog.properties");
	IRCConnectDialog() {
		def settings = JinroSettings.getSettings("irc.ini");
		def host = settings.getStringData("host", "chat01.ustream.tv");
		def port = settings.getIntData("port", 6667);
		def nick = settings.getStringData("nick", "jinrose-bot");
		def user = settings.getStringData("user");
		def name = settings.getStringData("name", "Jinro! SE IRC Bot");
		def pass = "";
		def charset = settings.getStringData("charset", "UTF-8");
		def channel = settings.getStringData("channel");
		
		def dialog = JinroInterface.makeDialog(strings.getString("ircconnect.title"), JinroInterface.mainwindow);
		def composite = new Composite(dialog, SWT.NONE);
		composite.layoutData = new GridData(GridData.FILL_HORIZONTAL);
		composite.layout = new GridLayout(2, false);
		def txtlayout = new GridData();
		txtlayout.widthHint = 120;
		def svlabel = new Label(composite, SWT.NONE);
		svlabel.text = strings.getString("irc.host");
		def svtext = new Text(composite, SWT.BORDER);
		svtext.layoutData = txtlayout;
		svtext.text = host;
		def ptlabel = new Label(composite, SWT.NONE);
		ptlabel.text = strings.getString("irc.port");
		def ptnum = new Spinner(composite, SWT.BORDER);
		ptnum.layoutData = txtlayout;
		ptnum.minimum = 0;
		ptnum.maximum = 65535;
		ptnum.selection = Integer.valueOf(port);
		def pslabel = new Label(composite, SWT.NONE);
		pslabel.text = strings.getString("irc.password");
		def pstext = new Text(composite, SWT.BORDER | SWT.PASSWORD);
		pstext.layoutData = txtlayout;
		pstext.text = "";
		def chlabel = new Label(composite, SWT.NONE);
		chlabel.text = strings.getString("irc.mainch");
		def chtext = new Text(composite, SWT.BORDER);
		chtext.layoutData = txtlayout;
		chtext.text = channel;
		def nklabel = new Label(composite, SWT.NONE);
		nklabel.text = strings.getString("irc.nick");
		def nktext = new Text(composite, SWT.BORDER);
		nktext.layoutData = txtlayout;
		nktext.text = nick;
		def lilabel = new Label(composite, SWT.NONE);
		lilabel.text = strings.getString("irc.user");
		def litext = new Text(composite, SWT.BORDER);
		litext.layoutData = txtlayout;
		litext.text = user;
		def nmlabel = new Label(composite, SWT.NONE);
		nmlabel.text = strings.getString("irc.name");
		def nmtext = new Text(composite, SWT.BORDER);
		nmtext.layoutData = txtlayout;
		nmtext.text = name;
		def cslabel = new Label(composite, SWT.NONE);
		cslabel.text = strings.getString("irc.encoding");
		def cstext = new Combo(composite, SWT.READ_ONLY);
		cstext.layoutData = txtlayout;
		cstext.add("UTF-8");
		strings.getString("irc.encoding.list").split(/\|/).toList().each { cstext.add(it) };
		cstext.text = charset;
		def buttons = JinroInterface.makeButtons([strings.getString("dialog.ok"), strings.getString("dialog.cancel")] as String[], dialog);
		buttons[0].addSelectionListener([
			widgetSelected: {
				host = svtext.text;
				port = ptnum.selection;
				nick = nktext.text;
				user = litext.text;
				name = nmtext.text;
				pass = pstext.text;
				charset = cstext.text;
				channel = chtext.text;
				settings.setData("host", host);
				settings.setData("port", port);
				settings.setData("nick", nick);
				settings.setData("user", user);
				settings.setData("name", name);
				settings.setData("charset", charset);
				settings.setData("channel", channel);
				settings.store();
				JinroGame.getProperty("ircConnector").disconnect();
				JinroGame.getProperty("ircConnector").connect(
					host   : host,
					port   : port,
					nick   : nick,
					user   : user,
					name   : name,
					pass   : pass,
					charset: charset,
					mainch : channel
				);
				dialog.dispose();
			}
		] as SelectionAdapter);
		buttons[1].addSelectionListener([
			widgetSelected: {
				dialog.dispose();
			}
		] as SelectionAdapter);
		dialog.pack();
		JinroInterface.setLocationToCenterParent(dialog);
		dialog.open();
	}
}