package scripts;

import groovy.swing.*;
import jinro.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;

class IRCConnectDialog {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("IRCConnectDialog.properties");
	IRCConnectDialog() {
		def settings = JinroSettings.getSettings("irc.ini");
		def host = settings.getStringData("host", "chat1.ustream.tv");
		def port = settings.getIntData("port", 6667);
		def nick = settings.getStringData("nick", "jinrose-bot");
		def user = settings.getStringData("user");
		def name = settings.getStringData("name", "Jinro! SE IRC Bot");
		def pass = "";
		def charset = settings.getStringData("charset", "UTF-8");
		def channel = settings.getStringData("channel");
		
		//def dialog = JinroInterface.makeDialog(strings.getString("ircconnect.title"), JinroInterface.mainwindow);
		def swing = new SwingBuilder();
		def size = [130, swing.textField().preferredSize.height as int];
		def svtext;
		def ptnum;
		def pstext;
		def chtext;
		def nktext;
		def litext;
		def nmtext;
		def cstext;
		def gbcp = [fill: GridBagConstraints.HORIZONTAL, insets: [3, 3, 3, 3]];
		def dialog;
		def buttons = [
			{ swing.button(text: strings.getString("dialog.ok"), actionPerformed: {
				host = svtext.text;
				port = ptnum.value;
				nick = nktext.text;
				user = litext.text;
				name = nmtext.text;
				pass = pstext.text;
				charset = cstext.selectedItem;
				channel = chtext.text;
				settings.setData("host", host);
				settings.setData("port", port);
				settings.setData("nick", nick);
				settings.setData("user", user);
				settings.setData("name", name);
				settings.setData("charset", charset);
				settings.setData("channel", channel);
				settings.store();
				JinroGame.getProperty("ircConnector").disconnect();
				JinroGame.getProperty("ircConnector").connect(
					host   : host,
					port   : port,
					nick   : nick,
					user   : user,
					name   : name,
					pass   : pass,
					charset: charset,
					mainch : channel
				);
				dialog.dispose();
			}) },
			{ swing.button(text: strings.getString("dialog.cancel"), actionPerformed: {
				dialog.dispose();
			}) }
		];
		dialog = swing.dialog(
			owner: JinroInterface.mainwindow,
			title: strings.getString("ircconnect.title"),
			pack: true,
			resizable: false
		) {
			boxLayout(axis: BoxLayout.Y_AXIS)
			panel() {
				boxLayout(axis: BoxLayout.X_AXIS)
				panel() {
					gridBagLayout()
					label(text: strings.getString("irc.host"), constraints: gbc(gbcp))
					svtext = textField(text: host, preferredSize: size, constraints: gbc(gbcp))
					label(text: strings.getString("irc.port"), constraints: gbc(gbcp << [gridy: 1]))
					ptnum = spinner(value: port, constraints: gbc(gbcp)) {
						spinnerNumberModel(minimum: 0, maximum: 65535)
					}
					label(text: strings.getString("irc.password"), constraints: gbc(gbcp << [gridy: 2]))
					pstext = passwordField(constraints: gbc(gbcp))
					label(text: strings.getString("irc.mainch"), constraints: gbc(gbcp << [gridy: 3]))
					chtext = textField(text: channel, constraints: gbc(gbcp))
					label(text: strings.getString("irc.nick"), constraints: gbc(gbcp << [gridy: 4]))
					nktext = textField(text: nick, constraints: gbc(gbcp))
					label(text: strings.getString("irc.user"), constraints: gbc(gbcp << [gridy: 5]))
					litext = textField(text: user, constraints: gbc(gbcp))
					label(text: strings.getString("irc.name"), constraints: gbc(gbcp << [gridy: 6]))
					nmtext = textField(text: name, constraints: gbc(gbcp))
					label(text: strings.getString("irc.encoding"), constraints: gbc(gbcp << [gridy: 7]))
					cstext = comboBox(constraints: gbc(gbcp), items: ("UTF-8|" + strings.getString("irc.encoding.list")).split(/\|/))
				}
			}
			panel() {
				flowLayout(alignment: FlowLayout.TRAILING)
				def btns = [];
				if(JinroInterface.isMac || JinroInterface.isGnome) {
					btns[1] = buttons[1]()
					btns[0] = buttons[0]()
				} else {
					btns[0] = buttons[0]()
					btns[1] = buttons[1]()
				}
				def btnsize = [Math.max(btns[0].preferredSize.width, btns[1].preferredSize.width) as int, btns[0].preferredSize.height as int];
				btns.each {
					it.preferredSize = btnsize;
				};
				btns[0].rootPane.defaultButton = btns[0];
			}
		};
		dialog.locationRelativeTo = JinroInterface.mainwindow;
		dialog.visible = true;
	}
}