package scripts;

import jinro.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.dnd.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

class Initialize {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("Initialize.properties");
	def init() {
		def game = JinroInterface.mainwindow.menuBar.items.toList().find{ it.text == JinroInterface.getTextWithMnemonic("menu.game") };
		def entry = game.menu.items.toList().find{ it.text == JinroInterface.getTextWithMnemonic("menu.game.entry") };
		entry.getListeners(SWT.Selection).toList().each {
			entry.removeListener(SWT.Selection, it);
		};
		entry.addSelectionListener([
			widgetSelected: {
				if(JinroGame.invokeMethod("waitforEntrant", new Object[0])) {
					JinroGame.invokeMethod("noticeall", [strings.getString("game.waitEntrant")] as Object[]);
				} else {
					JinroGame.getProperty("ircConnector").addLog(strings.getString("irc.unconnected"));
				}
			}
		] as SelectionAdapter);
		def connect = setMenuText(new MenuItem(game.menu, SWT.PUSH, 0), "game.irc.connect");
		connect.addSelectionListener([
			widgetSelected: {
				JinroGame.getProperty("GUI").IRCConnectDialog.newInstance();
			}
		] as SelectionAdapter);
		new MenuItem(game.menu, SWT.SEPARATOR, 2);
		def viewer = setMenuText(new MenuItem(game.menu, SWT.PUSH, 3), "game.irc.viewer");
		viewer.addSelectionListener([
			widgetSelected: {
				JinroGame.getProperty("GUI").IRCViewer.newInstance();
			}
		] as SelectionAdapter);
	}
	def setMenuText(item, prop) {
		def text = new StringBuilder(strings.getString(prop));
		int index = text.size() + 1;
		while(index && (index = text.lastIndexOf("&", index - 1)) >= 0) {
			text.replace(index, index, "&");
		}
		def mnemonic = strings.getString(prop + ".key");
		if(mnemonic.size() == 1 && mnemonic != "&") {
			index = text.indexOf(mnemonic);
			if(index < 0) {
				index = text.indexOf(mnemonic.toLowerCase());
				if(index < 0) {
					index = text.indexOf(mnemonic.toUpperCase());
				}
			}
			if(index >= 0) {
				text.replace(index, index, "&");
			} else {
				text << "(&" << mnemonic << ")";
			}
		}
		item.text = text;
		return item;
	}
}
