package scripts;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import jinro.*;

class Initialize {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("Initialize.properties");
	def init() {
		def game = JinroInterface.mainwindow.JMenuBar.subElements.toList().find{ (it instanceof JMenu) && it.text == JinroInterface.getTextWithMnemonic("menu.game") };
		def entry = game.menuComponents.toList().find{ it instanceof JMenuItem && it.text == JinroInterface.getTextWithMnemonic("menu.game.entry") };
		entry.getActionListeners().toList().each {
			entry.removeActionListener(it);
		};
		entry.addActionListener([
			actionPerformed: {
				if(JinroGame.getProperty("ircConnector").connection) {
					JinroGame.invokeMethod("waitforEntrant", [] as Object[]);
					JinroGame.invokeMethod("noticeall", [strings.getString("game.waitEntrant")] as Object[]);
				} else {
					JinroGame.getProperty("ircConnector").addLog(strings.getString("irc.unconnected"));
				}
			}
		] as ActionListener);
		def connect = setMenuText(new JMenuItem(), "game.irc.connect");
		connect.addActionListener([
			actionPerformed: {
				JinroGame.getProperty("GUI").IRCConnectDialog.newInstance();
			}
		] as ActionListener);
		game.insert(connect, 0);
		game.insertSeparator(2);
		def viewer = setMenuText(new JMenuItem(), "game.irc.viewer");
		viewer.text = strings.getString("game.irc.viewer");
		viewer.addActionListener([
			actionPerformed: {
				JinroGame.getProperty("GUI").IRCViewer.newInstance();
			}
		] as ActionListener);
		game.insert(viewer, 3);
	}
	def setMenuText(item, prop) {
		def text = strings.getString(prop);
		def mnemonic = strings.getString(prop + ".key");
		if(mnemonic.size() == 1 && mnemonic != "&" && !JinroInterface.isMac) {
			if(text.toLowerCase().indexOf(mnemonic.toLowerCase()) < 0) {
				text += "(" + mnemonic + ")";
			}
			item.mnemonic = mnemonic.charAt(0);
		}
		item.text = text;
		return item;
	}
}
